#include <sdktools>

char g_szMusicConfigLocation[PLATFORM_MAX_PATH];
char g_szUserMusicKitID[MAXPLAYERS + 1][64];

ConVar g_cBombPlanted = null;
ConVar g_cIgnoreUserMusic = null;

Handle g_iTimer = INVALID_HANDLE;

bool g_bIsFreshRound[MAXPLAYERS + 1] = true;
bool g_bRoundHasEnded = false;
bool g_bIsRoundBusy = false;

int g_iMVPClient = 0;

Database db = null;


public Plugin myinfo =  {
	name = "[CS:GO] Custom Music Kits (By noBrain)", 
	author = "noBrain", 
	description = "Provide in-game custom csgo musics kits", 
	version = "1.4.5", 
};


public void OnPluginStart()
{
	RegConsoleCmd("sm_cmu", Command_MusicKits);
	BuildPath(Path_SM, g_szMusicConfigLocation, sizeof(g_szMusicConfigLocation), "configs/music.txt");
	
	g_cBombPlanted = FindConVar("mp_c4timer");
	g_cIgnoreUserMusic = CreateConVar("sm_ignore_user_music", "0", "If enabled, user owned music kits (valve musics) will be ignored.");
	
	//Hooks
	HookEvent("player_death", Event_PlayerDeath, EventHookMode_Post);
	HookEvent("bomb_planted", Event_BombPlanted, EventHookMode_Post);
	HookEvent("hostage_follows", Event_HostageTaken, EventHookMode_Post)
	HookEvent("round_end", Event_RoundEnd, EventHookMode_Pre);
	HookEvent("round_start", Event_RoundStart, EventHookMode_Post);
	HookEvent("round_mvp", Event_RoundMVP, EventHookMode_Post);
	HookEvent("round_time_warning", Event_RoundTenSec, EventHookMode_Post);
	HookEvent("player_disconnect", Event_PlayerDisconnect, EventHookMode_Pre);
	
	CreateDatabase();
}

public void OnGameFrame()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i) && IsUserWithCustomMusicKit(i) && GetConVarBool(g_cIgnoreUserMusic))
		{
			ClientCommand(i, "playgamesound Music.StopAllMusic");
		}
	}
}

public void OnClientPostAdminCheck(int client)
{
	if(IsValidClient(client))
	{
		if (RecoverUserMusic(client))
		{
			PrintToConsole(client, " \x04[Custom-MusicKit]\x01 Your music kit of choice has restored.");
		}
		else
		{
			PrintToConsole(client, " \x04[Custom-MusicKit]\x01 Error restoring your kit.");
		}
	}
		
}

public Action OnPlayerRunCmd(int client, int &buttons)
{
	if (GameRules_GetProp("m_bFreezePeriod") != 1)
	{
		if (buttons & IN_FORWARD)
		{
			if (g_bIsFreshRound[client])
			{
				g_bIsFreshRound[client] = false;
				playSound(client, "RoundStart_Action");
			}
		}
	}
}

public Action Event_RoundTenSec(Event event, const char[] name, bool dontBroadcast)
{
	if (!g_bRoundHasEnded && !g_bIsRoundBusy)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && !IsFakeClient(i))
			{
				playSound(i, "Round_TenSeconds");
			}
		}
	}
}

public Action Event_RoundStart(Event event, const char[] name, bool dontBroadcast)
{
	g_bRoundHasEnded = false;
	g_bIsRoundBusy = false;
	PrintToChatAll(" \x04[Custom-MusicKit]\x01 Type \x02!cmu\x01 to use custom music kits (with mvp sound).");
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i))
		{
			g_bIsFreshRound[i] = true;
			g_iMVPClient = 0;
		}
	}
}


public Action Event_RoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	g_bRoundHasEnded = true;
	if (g_iTimer != INVALID_HANDLE)
	{
		KillTimer(g_iTimer);
		g_iTimer = INVALID_HANDLE;
	}
	
	
	
	if (g_iMVPClient != 0)
	{
		PlayMVPSound(g_iMVPClient, "Round_MVP");
	}
	else
	{
		int winner = event.GetInt("winner");
		//PrintToChatAll("WON NUM: %d", winner)
		if (winner == 3)
		{
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsClientInGame(i) && !IsFakeClient(i))
				{
					if (GetClientTeam(i) == 3)
					{
						playSound(i, "RoundEnt_Won");
					}
					else if (GetClientTeam(i) == 2)
					{
						playSound(i, "RoundEnd_Lost");
					}
				}
			}
		}
		else if (winner == 2)
		{
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsClientInGame(i) && !IsFakeClient(i))
				{
					if (GetClientTeam(i) == 2)
					{
						playSound(i, "RoundEnt_Won");
					}
					else if (GetClientTeam(i) == 3)
					{
						playSound(i, "RoundEnd_Lost");
					}
				}
			}
		}
	}
}

public Action Event_PlayerDisconnect(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	Format(g_szUserMusicKitID[client], sizeof(g_szUserMusicKitID[]), "");
}


public Action Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast)
{
	if (!g_bRoundHasEnded && !g_bIsRoundBusy)
	{
		int client = GetClientOfUserId(event.GetInt("userid"));
		playSound(client, "Deathcam");
	}
}

public Action Event_RoundMVP(Event event, const char[] name, bool dontBroadcast)
{
	if (!StrEqual(g_szUserMusicKitID[GetClientOfUserId(event.GetInt("userid"))], ""))
	{
		g_iMVPClient = GetClientOfUserId(event.GetInt("userid"));
	}
}

public Action Event_HostageTaken(Event event, const char[] name, bool dontBroadcast)
{
	g_bIsRoundBusy = true;
	if (!g_bRoundHasEnded)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && !IsFakeClient(i))
			{
				playSound(i, "Bomb_Planted");
			}
		}
	}
}

public Action Event_BombPlanted(Event event, const char[] name, bool dontBroadcast)
{
	g_bIsRoundBusy = true;
	if (!g_bRoundHasEnded)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && !IsFakeClient(i))
			{
				playSound(i, "Bomb_Planted");
			}
		}
		float BombTimer = float(GetConVarInt(g_cBombPlanted)) - 10.0;
		g_iTimer = CreateTimer(BombTimer, Timer_10SecExplode);
	}
}
public Action Timer_10SecExplode(Handle timer)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i))
		{
			playSound(i, "Bomb_TenSeconds");
		}
	}
	g_iTimer = INVALID_HANDLE;
}

public Action Command_MusicKits(int client, int args)
{
	showMusicMenu(client);
	return Plugin_Handled;
}

stock void setMusicKit(int client, char[] music_id)
{
	Format(g_szUserMusicKitID[client], sizeof(g_szUserMusicKitID[]), "%s", music_id);
}

stock bool playSound(int client, char[] playText)
{
	if(!GetConVarBool(g_cIgnoreUserMusic))
	{
		if(!IsUserWithMusicKit(client))
		{
			Handle kv = CreateKeyValues("musics");
			FileToKeyValues(kv, g_szMusicConfigLocation);
			if (KvJumpToKey(kv, g_szUserMusicKitID[client], false))
			{
				char SoundName[128];
				KvGetString(kv, playText, SoundName, sizeof(SoundName), "NULL");
				if (!StrEqual(SoundName, "NULL", false))
				{
					ClientCommand(client, "play *%s", SoundName);
					//CreateTimer(GetConVarFloat(g_cStopDelay), Timer_StartActionPlay, client, TIMER_FLAG_NO_MAPCHANGE);
					return true;
				}
				else
				{
					CloseHandle(kv);
					return false;
				}
			}
			else
			{
				CloseHandle(kv);
				return false;
			}
		}
		else
		{
			return false;
		}
	}
	else
	{
		Handle kv = CreateKeyValues("musics");
		FileToKeyValues(kv, g_szMusicConfigLocation);
		if (KvJumpToKey(kv, g_szUserMusicKitID[client], false))
		{
			char SoundName[128];
			KvGetString(kv, playText, SoundName, sizeof(SoundName), "NULL");
			if (!StrEqual(SoundName, "NULL", false))
			{
				ClientCommand(client, "play *%s", SoundName);
				//CreateTimer(GetConVarFloat(g_cStopDelay), Timer_StartActionPlay, client, TIMER_FLAG_NO_MAPCHANGE);
				return true;
			}
			else
			{
				CloseHandle(kv);
				return false;
			}
		}
		else
		{
			CloseHandle(kv);
			return false;
		}
	}
	
}

stock bool IsUserWithMusicKit(int client)
{
	int i_iUserMusicValue = GetEntProp(client, Prop_Send, "m_unMusicID");
	if(i_iUserMusicValue >= 3)
	{
		return true;
	}
	else
	{
		return false;
	}
}

stock bool IsUserWithCustomMusicKit(int client)
{
	if(!StrEqual(g_szUserMusicKitID[client], "", false))
	{
		return true;
	}
	else
	{
		return false;
	}
}

stock void PlayMVPSound(int client, char[] playText)
{
	if(GetConVarBool(g_cIgnoreUserMusic))
	{
		if(IsUserWithCustomMusicKit(client))
		{
			Handle kv = CreateKeyValues("musics");
			FileToKeyValues(kv, g_szMusicConfigLocation);
			if (KvJumpToKey(kv, g_szUserMusicKitID[client], false))
			{
				char SoundName[128];
				KvGetString(kv, playText, SoundName, sizeof(SoundName), "NULL");
				if (!StrEqual(SoundName, "NULL", false))
				{
					for (int i = 1; i <= MaxClients; i++)
					{
						if (IsClientInGame(i) && !IsFakeClient(i))
						{
							ClientCommand(i, "play *%s", SoundName);
							//CreateTimer(GetConVarFloat(g_cStopDelay), Timer_StartActionPlay, client, TIMER_FLAG_NO_MAPCHANGE);
							ClientCommand(i, "playgamesound Music.StopAllMusic");
						}
					}
				}
				else
				{
					CloseHandle(kv);
				}
			}
			else
			{
				CloseHandle(kv);
			}
		}
	}
}

stock void showMusicMenu(int client)
{
	char MusicName[32], MusicID[64];

	Handle menu = CreateMenu(MusicMenu);
	Handle kv = CreateKeyValues("musics");
	FileToKeyValues(kv, g_szMusicConfigLocation);
	SetMenuTitle(menu, "Select a music:");
	AddMenuItem(menu, "Music_Disable", "Disable");
	KvGotoFirstSubKey(kv, false);
	do
	{
		KvGetString(kv, "name", MusicName, sizeof(MusicName), "NULL");
		KvGetSectionName(kv, MusicID, sizeof(MusicID));
		AddMenuItem(menu, MusicID, MusicName);
	}
	while (KvGotoNextKey(kv, false));
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
	SetMenuExitButton(menu, true);
	CloseHandle(kv);
}
public int MusicMenu(Handle menu, MenuAction action, int param1, int param2)
{
	char MusicID[64];
	Handle kv = CreateKeyValues("musics");
	FileToKeyValues(kv, g_szMusicConfigLocation);
	
	switch (action)
	{
		case MenuAction_Select:
		{
			char item[64];
			GetMenuItem(menu, param2, item, sizeof(item));
			
			if (StrEqual(item, "Music_Disable", false))
			{
				if (RemoveUserMusic(param1))
				{
					PrintToChat(param1, " \x04[Custom-MusicKit]\x01 Your data has been cleared.");
				}
				else
				{
					PrintToChat(param1, " \x04[Custom-MusicKit]\x01 error clearing your data.");
				}
				g_szUserMusicKitID[param1] = "";
				CloseHandle(kv);
				CloseHandle(menu);
			}
			
			
			KvGotoFirstSubKey(kv, false);
			do
			{
				KvGetSectionName(kv, MusicID, sizeof(MusicID));
				if (StrEqual(item, MusicID))
				{
					if (SaveUserMusic(param1, MusicID))
					{
						PrintToChat(param1, " \x04[Custom-MusicKit]\x01 Your choice has saved to the database!");
					}
					else
					{
						PrintToChat(param1, " \x04[Custom-MusicKit]\x01 error saving your choice to the database!");
					}
					setMusicKit(param1, MusicID);
					CloseHandle(kv);
					break;
				}
				else if (KvGotoNextKey(kv, false))
				{
					continue;
				}
				else
					break;
			}
			while (!StrEqual(item, MusicID));
		}
		case MenuAction_End:
		{
			CloseHandle(kv);
			CloseHandle(menu);
		}
	}
}

stock bool IsMapHostage()
{
	for (int entity = 1; entity <= 4096; entity++)
	{
		if (IsValidEntity(entity))
		{
			char ClassName[32];
			GetEntityClassname(entity, ClassName, sizeof(ClassName))
			if (StrEqual(ClassName, "func_hostage_rescue", false))
			{
				return true;
			}
			else
			{
				continue;
			}
		}
	}
	return false;
}

stock void CreateDatabase()
{
	char err[255];
	db = SQL_Connect("MusicKits", true, err, sizeof(err));
	if (db == null)
	{
		PrintToServer("[Custom-MusicKits] Cannot connect to the database, error: %s", err);
	}
	else
	{
		if (!SQL_FastQuery(db, "CREATE TABLE IF NOT EXISTS userkit (id VARCHAR NOT NULL, kit VARCHAR NOT NULL);"))
		{
			SQL_GetError(db, err, sizeof(err));
			PrintToServer("[Custom-MusicKits] Failed to create the table, error: %s", err);
		}
		else
		{
			PrintToServer("[Custom-MusicKits] Table has created if not existed.");
		}
	}
}

stock bool SaveUserMusic(int client, char[] MusicID)
{
	char err[255], SteamAuth[32];
	GetClientAuthId(client, AuthId_Steam2, SteamAuth, sizeof(SteamAuth));
	//Database db = SQL_Connect("MusicKits", true, err, sizeof(err));
	if (db == null)
	{
		PrintToServer("[Custom-MusicKits] Cannot connect to the database, error: %s", err);
		return false;
	}
	else
	{
		if (IsUserOnDatabase(client))
		{
			PrintToServer("[Custom-MusicKit] User is already on database");
			char Query[128];
			
			Format(Query, sizeof(Query), "UPDATE userkit SET kit='%s' WHERE id='%s'", MusicID, SteamAuth);
			
			
			if (SQL_FastQuery(db, Query))
			{
				return true;
			}
			else
			{
				return false;
			}
			
			/*
			DBStatement statement = null;
			statement = SQL_PrepareQuery(db, "UPDATE userkit SET kit=? WHERE id = ?", err, sizeof(err));
			if(statement == null)
			{
				PrintToServer("[Custom-MusicKits] An error occured, error: %s", err);
				delete statement;
				return false;
			}
			else
			{
				SQL_BindParamString(statement, 0, SteamAuth, false);
				SQL_BindParamString(statement, 1, MusicID, false);
				if(!SQL_Execute(statement))
				{
					delete statement;
					return false;
				}
				else
				{
					delete statement;
					return true;
				}
			}
			*/
		}
		else
		{
			PrintToServer("[Custom-MusicKit] New user data being inserted.");
			DBStatement statement = null;
			statement = SQL_PrepareQuery(db, "INSERT INTO userkit (id, kit) VALUES(? ,?)", err, sizeof(err));
			if (statement == null)
			{
				PrintToServer("[Custom-MusicKits] An error occured, error: %s", err);
				delete statement;
				return false;
			}
			else
			{
				SQL_BindParamString(statement, 0, SteamAuth, false);
				SQL_BindParamString(statement, 1, MusicID, false);
				if (!SQL_Execute(statement))
				{
					delete statement;
					return false;
				}
				else
				{
					delete statement;
					return true;
				}
			}
		}
		
	}
}

stock bool IsUserOnDatabase(int client)
{
	char Query[128], SteamAuth[32], err[255];
	GetClientAuthId(client, AuthId_Steam2, SteamAuth, sizeof(SteamAuth));
	DBResultSet hQuery = null;
	Format(Query, sizeof(Query), "SELECT * FROM userkit");
	hQuery = SQL_Query(db, Query);
	while (SQL_FetchRow(hQuery))
	{
		SQL_FetchString(hQuery, 0, Query, sizeof(Query));
		if (StrEqual(Query, SteamAuth, false))
		{
			return true;
		}
	}
	
	delete hQuery;
	return false;
	
	/*
	DBStatement stmt = null;
	
	stmt = SQL_PrepareQuery(db, "SELECT kit FROM userkit WHERE id = ?", err, sizeof(err));
	if(stmt == null)
	{
		PrintToServer("DOOL 1")
		return false;
	}
	else
	{
		SQL_BindParamString(stmt, 0, SteamAuth, false);
		if(!SQL_Execute(stmt))
		{
			PrintToServer("DOOL 2")
			return false;
		}
		else
		{
			PrintToServer("DOOL 3")
			return true;
		}
	}

	DBResultSet hQuery = null;
	Format(Query, sizeof(Query), "SELECT kit FROM userkit WHERE id = '%s'", SteamAuth);
	
	hQuery = SQL_Query(db, Query);
	if(hQuery == null)
	{
		delete hQuery;
		return false;
	}
	else
	{
		delete hQuery;
		return true;
	}
	*/
	
	
}

stock bool RecoverUserMusic(int client)
{
	DBResultSet hQuery = null;
	char Query[128], SteamAuth[32], KitID[64];
	GetClientAuthId(client, AuthId_Steam2, SteamAuth, sizeof(SteamAuth));
	Format(Query, sizeof(Query), "SELECT kit FROM userkit WHERE id = '%s'", SteamAuth);
	
	hQuery = SQL_Query(db, Query);
	if (hQuery == null)
	{
		PrintToServer("[Custom-MusicKits] Could not execute the query.");
		return false;
	}
	else
	{
		SQL_FetchString(hQuery, 0, KitID, sizeof(KitID));
		setMusicKit(client, KitID);
		return true;
	}
	
	
}
stock bool RemoveUserMusic(int client)
{
	char Query[128], err[255], SteamAuth[32];
	GetClientAuthId(client, AuthId_Steam2, SteamAuth, sizeof(SteamAuth));
	Format(Query, sizeof(Query), "DELETE FROM userkit WHERE id='%s';", SteamAuth);
	if (!SQL_FastQuery(db, Query))
	{
		SQL_GetError(db, err, sizeof(err));
		PrintToServer("[Custom-MusicKit] An error occured!, Error: %s", err);
		return false;
	}
	else
	{
		return true;
	}
} 

stock bool IsValidClient(int client)
{
	if(IsClientInGame(client) && !IsFakeClient(client))
	{
		return true;
	}
	else
	{
		return false;
	}
}

